export declare type DeepReadonly<T> = T extends Function ? T : {
    readonly [P in keyof T]: DeepReadonly<T[P]>;
};
export declare type AtomSubscription<T> = (value: DeepReadonly<T>) => void;
export declare class Atom<T> {
    private _value;
    private _subscriptions;
    constructor(initialValue: T);
    get value(): DeepReadonly<T>;
    set value(value: T);
    subscribe(subscription: AtomSubscription<T>): () => void;
}
export declare const createAtom: <T>(initialValue: T) => Atom<T>;
